# This file allows the end user to add methods to the SIMDIS Label Python code.
# In the Python code the methods defined here will need to be reference from simdis
# namespace, i.e., simdis.methodName().  This file must be named simdis.py and must
# be in the $(SIMDIS_HOME) directory.  The file may reference other modules in the
# $(SIMDIS_HOME) directory.  The file is only loaded once when the first Python code
# is executed.

# If changes are made to this file while SIMDIS is open, SIMDIS must be restarted in
# order for this file to be reloaded.

# Python tutorials
# https://www.tutorialspoint.com/python/python_functions.htm
# https://www.codementor.io/kaushikpal/user-defined-functions-in-python-8s7wyc8k2
# https://anh.cs.luc.edu/python/hands-on/3.1/handsonHtml/functions.html

# import SIMDIS PIData module (PIData.clockGetTime)
import PIData
# import Python math module (math.fmod)
import math

# Example method to flash a time "Late" label under an affected object
# To use in a python label:
# return simdis.timeLateFlash(point.time)
def timeLateFlash(pointTime):
  systime = PIData.clockGetTime()
  late = int(systime - pointTime)
  # Blink label every 3 seconds if the object has not been updated in the past 60 secs
  if late > 60 and math.fmod(int(systime), 5) < 3:
    return 'Late: ' + str(late) + ' secs'
  else:
    return ''
